--- probe	2016-03-02 21:00:46.000000000 +0100
+++ probe.new	2017-01-17 11:55:41.817772545 +0100
@@ -139,18 +139,7 @@
 }
 
 list_nvme() {
-  # find drive
-  DRV=`expr $2 / 8`
-  NUM=`expr $2 % 8`
-  if [ "$NUM" = "0" ]; then
-     # Not sure if /dev/nvme0 and /dev/nvme0n1 are both valid forms (depending on
-     # hardware), so we'll just try both:
-     fdisk -l /dev/nvme$DRV >> $TMP/SeTfdisk 2> /dev/null
-     fdisk -l /dev/nvme${DRV}n1 >> $TMP/SeTfdisk 2> /dev/null
-     #output_gpt_partitions /dev/nvme$DRV >> $TMP/SeTfdisk
-  else
-     return
-  fi
+  fdisk -l | grep $1 >> $TMP/SeTfdisk 2> /dev/null
 }
 
 is_swap() {
@@ -404,7 +393,9 @@
     elif [ "$MAJOR" = "179" ]; then
       list_mmc $MAJOR $MINOR
     elif [ "$MAJOR" = "259" ]; then
-      list_nvme $MAJOR $MINOR
+      if echo $line | grep -q p; then
+        list_nvme $DEVNAME
+      fi
     elif [ $(expr $DEVNAME : 'x\?vd[^0-9]*$') -ne 0 ]; then
       # The virtio devices have no set major dev number, so we have to search
       # by name.  Matches full drive names for KVM/lguest (vda) and Xen (xvda).
